//
// Created by Alvin on 2018/5/8.
//

#ifndef LIBNETSDK_SDK_DEFINE_H
#define LIBNETSDK_SDK_DEFINE_H

//#include "platform.h"
//接口头
#define LIB_NETSDK_API 

#define MAX_IP_NAME_LEN 64

typedef struct _updpackhead
{
	unsigned long frame_timestamp;
	unsigned long keyframe_timestamp;
	unsigned short pack_seq;
	unsigned short payload_size;
	unsigned char pack_type;//0x01 first packet锟斤拷x10 last packet, 0x11 first and last packet锟斤拷x00 middle packet
	unsigned char frame_type;
	unsigned char stream_type;//0: video, 1: audio
	unsigned char stream_index;
	unsigned int  frame_index;
}UpdPackHead;

//搜索回调事件
enum AJ_SEARCH_EVENT
{
    EVENT_SEARCH_RECV_NEWIPCINFO = 1,
    EVENT_SEARCH_UPDATEINFO,
};

enum AJ_REALPLAY_STATUS_EVENT_CODE
{
	AJ_RTSP_CLIENT_EVET_CODE = 10000,
	AJ_RTSP_CLIENT_EVET_CODE_RTSP_AUTH_FAILED,
	//	AJ_RTSP_CLIENT_EVET_CODE_RTSP_ERR
};

//网络连接类型
enum AJ_CONNECT_TYPE{
    AJ_TYPE_Udp = 0,
    AJ_TYPE_Tcp,
    AJ_TYPE_Multicast,
};

enum AJ_AUDIO_TYPE{
    AJ_TYPE_AUDIO_UNINIT = -1,
    AJ_TYPE_AUDIO_PCMU,
    AJ_TYPE_AUDIO_AAC_LC,
    AJ_TYPE_AUDIO_PCMA,
    AJ_TYPE_AUDIO_PCM,
    AJ_TYPE_AUDIO_OPUS,
    AJ_TYPE_AUDIO_MP3,
};

//接口返回定义

enum AJ_ERROR_CODE
{
    ERR_NOT_FIND_DEVICE = -9000002,
    ERR_OPEN_AUDIOCAPTURE_FAIL,
    ERR_START_AUDIOCAPTURE_FAIL,
    ERR_AUDIO_PARAM_ERROR,
    ERR_AUDIO_NOT_START,
    ERR_DEV_NOT_CONNECTED,
    ERR_DEV_NOT_LOGIN,
    ERR_MSGTYPE_ERROR,
    ERR_OUTOFF_MEMORY,
    ERR_INIT_SOCKET_ERROR,
    ERR_PARAM_ERROR,
    ERR_NOT_DEV_EXIST,
    ERR_START_THREADERROR,
    ERR_NOT_FIND_STREAM,
    ERR_ISUPLOADING_ERROR,
    ERR_ISDOWNLOADING_ERROR,
    ERR_IS_STARTAUDIO_ERROR,
    ERR_ISFINISH_ERROR,
    ERR_NOT_DOWNLOAD_MODE_ERROR,
    ERR_PTZCMD_ACTION_ERROR,
    ERR_LOC_FILE_ERROR,
    ERR_NOT_REPLAY_MODE_ERROR,
    ERR_PLAY_ACTION_ERROR,
    ERR_NOT_ALLOW_REPLAY_ERROR,
    ERR_MEMORY_SIZE_ERROR,
    ERR_XML_FORMAT_ERROR,
    ERR_CREATE_SOCKET_ERROR,
    ERR_SEND_MODIFYCMD_ERROR,
    ERR_NOT_STARTTALK_MODE_ERROR,
    ERR_RECORD_MEDIA_PARAM_ERROR,
    ERR_RECORD_CREATEERROR,
    ERR_RECORD_ISRECORDING,
    ERR_RECORD_FILEMAXSECONDS_ERROR,
    ERR_RECORD_ALLRECORDSECONDS_ERROR,
    ERR_RECORD_NOTRUNNING,
    ERR_RECORD_STREAMPARAM_ERROR,
    ERR_RECORD_WRITETEMPBUFFER_ERROR,
    ERR_RECORD_ISNOTRECORDSTREAM_MODE,
    ERR_RECORD_NOTINPUTSTREAM_MODE,
    ERR_RECORD_FILEPATH_ERROR,
    ERR_DLL_NOINITORRELEASE_ERROR,
    ERR_SERIAL_NOT_START,
    ERR_TCP_CONNECT_ERROR,
};

enum AJ_STATE_EVENT
{
    EVENT_CONNECTING,
    EVENT_CONNECTOK,
    EVENT_CONNECTFAILED,
    EVENT_SOCKETERROR,
    EVENT_LOGINOK,
    EVENT_LOGINFAILED,
    EVENT_STARTAUDIOOK,
    EVENT_STARTAUDIOFAILED,
    EVENT_STOPAUDIOOK,
    EVENT_STOPAUDIOFAILED,
    EVENT_SENDPTZOK,
    EVENT_SENDPTZFAILED,
    EVENT_SENDAUXOK,
    EVENT_SENDAUXFAILED,
    EVENT_UPLOADOK,
    EVENT_UPLOADFAILED,
    EVENT_DOWNLOADOK,
    EVENT_DOWNLOADFAILED,
    EVENT_REMOVEOK,
    EVENT_REMOVEFAILED,
    EVENT_SENDPTZERROR,
    EVENT_PTZPRESETINFO,
    EVNET_PTZNOPRESETINFO,
    EVENT_PTZALARM,
    EVENT_RECVVIDEOPARAM,
    EVENT_RECVAUDIOPARAM,
    EVENT_CONNECTRTSPERROR,
    EVENT_CONNECTRTSPOK,
    EVENT_RTSPTHREADEXIT,
    EVENT_URLERROR,
    EVENT_RECVVIDEOAUDIOPARAM,
    EVENT_LOGIN_USERERROR,
    EVENT_LOGOUT_FINISH,
    EVENT_LOGIN_RECONNECT,
    EVENT_LOGIN_HEARTBEAT_LOST,
    EVENT_STARTAUDIO_ISBUSY,
    EVENT_STARTAUDIO_PARAMERROR,
    EVENT_STARTAUDIO_AUDIODDISABLED,
    EVENT_CONNECT_RTSPSERVER_ERROR,
    EVENT_CREATE_RTSPCLIENT_ERROR,
    EVENT_GET_RTSP_CMDOPTION_ERROR,
    EVENT_RTSP_AUTHERROR,
    EVNET_RECORD_FILEBEGIN,
    EVENT_RECORD_FILEEND,
    EVENT_RECORD_TASKEND,
    EVENT_RECORD_DISKFREESPACE_TOOLOW,
    EVNET_RECORD_FILEBEGIN_ERROR,
    EVNET_RECORD_WRITE_FILE_ERROR,
    EVENT_RECORD_INITAVIHEAD_ERROR,
    EVENT_RECORD_MEDIA_PARAM_ERROR,
    EVENT_NVR_CHANNELS,
    EVENT_NVR_IPC_STATUS,
    EVENT_SYSTEMREBOOT_ANDRELOGINOK,
    EVENT_NETWORKRESET_ANDRELOGINOK,
    EVENT_UPLOAD_PROCESS,
    EVENT_DOWNLOAD_PROCESS,
    EVENT_DOWNLOAD_RETRY_ANDRESTAR,
    EVENT_LOGOUT_BYUSER,
    EVENT_P2P_CONNECT_STATE_INFO,
    EVNET_INITP2P_OK,
    EVNET_INITP2P_ERROR,
    EVENT_START_CONNECT_DEVICE,
    EVENT_START_CONNECT_DEVICE_ERROR,
    EVENT_P2PSERVER_LOGIN_OK,
    EVENT_P2PSERVER_LOGOUT,
    EVENT_P2PERROR_EVNETINFO,
    EVENT_P2PCONNECT_DEVICEOK,
    EVENT_P2PCONNECT_CLOSE,
    EVENT_P2P_EXIT_CONNECT,
    EVENT_CAPTURE_IMAGE_FINISH,
    EVENT_RECVABLITY_INFO,
    EVENT_P2P_CLINET_CHANNLEINFO,
    EVENT_P2P_STARTSTREAM_ERROR11,

};

enum AJ_ALARM_CODE{
    ALARM_CODE_BEGIN=0,
    ALARM_CODE_LINKDOWN=1,
    ALARM_CODE_LINKUP,
    ALARM_CODE_USB_PLUG,
    ALARM_CODE_USB_UNPLUG,
    ALARM_CODE_SD0_PLUG,
    ALARM_CODE_SD0_UNPLUG,
    ALARM_CODE_SD1_PLUG,
    ALARM_CODE_SD1_UNPLUG,
    ALARM_CODE_USB_FREESPACE_LOW,
    ALARM_CODE_SD0_FREESPACE_LOW,
    ALARM_CODE_SD1_FREESPACE_LOW,
    ALARM_CODE_VIDEO_LOST,
    ALARM_CODE_VIDEO_COVERD,
    ALARM_CODE_MOTION_DETECT,
    ALARM_CODE_GPIO3_HIGH2LOW,	//仅仅用于告警触发判断。IO报警使用ALARM_CODE_IO_ALARM和ALARM_CODE_IO_ALARM_FINISH
    ALARM_CODE_GPIO3_LOW2HIGH,	//仅仅用于告警触发判断。IO报警使用ALARM_CODE_IO_ALARM和ALARM_CODE_IO_ALARM_FINISH
    ALARM_CODE_STORAGE_FREESPACE_LOW,
    ALARM_CODE_RECORD_START,
    ALARM_CODE_RECORD_FINISHED,
    ALARM_CODE_RECORD_FAILED,
    ALARM_CODE_GPS_INFO,
    ALARM_CODE_EMERGENCY_CALL,
    ALARM_CODE_JPEG_CAPTURED,
    ALARM_CODE_RS485_DATA,
    ALARM_CODE_SAME_IP,
    ALARM_CODE_HW130_PIR,
    ALARM_CODE_LPR,	//车牌识别
    ALARM_CODE_AUDIO_BABYCRY,//婴儿啼哭
    ALARM_CODE_AUDIO_LSA,//高分贝声音
    ALARM_CODE_VIDEO_FORMAT_CHANGED,	//格式/分辨率更改，用于通知客户端重新配置解码器
    ALARM_CODE_VIDEO_GATE,//电子围栏
    ALARM_CODE_RESET_TO_FACTORY,//恢复出厂通知
    ALARM_CODE_MOTION_DETECT_DISAPPEAR,  //移动侦测告警消除
    ALARM_CODE_IO_ALARM,	//IO输入报警,用于一直按下的情况下，就一直告警
    ALARM_CODE_IO_ALARM_FINISH,	//IO输入报警结束
    ALARM_CODE_VIDEO_PD,	//人形检测
    ALARM_CODE_END
};

enum REPLAY_IPC_ACTION
{
    ACTION_PLAY = 0,
    ACTION_PAUSE,
    ACTION_RESUME,
    ACTION_FAST,
    ACTION_SLOW,
    ACTION_SEEK,
    ACTION_FRAMESKIP,
    ACTION_STOP,
    ACTION_CAPIMG = 10,
    ACTION_CHANGE_SOUND,
    ACTION_RECV_DECODEPARAM,
};

enum PTZ_CMD_TYPE
{
    LIGHT_PWRON = 2,
    WIPER_PWRON,
    FAN_PWRON,
    HEATER_PWRON,
    AUX_PWRON1,
    AUX_PWRON2,
    ZOOM_IN_VALUE = 11,
    ZOOM_OUT_VALUE,
    FOCUS_NEAR,
    FOCUS_FAR,
    IRIS_OPEN,
    IRIS_CLOSE,
    TILT_UP,
    TILT_DOWN,
    PAN_LEFT,
    PAN_RIGHT,
    UP_LEFT,
    UP_RIGHT,
    DOWN_LEFT,
    DOWN_RIGHT,
    PAN_AUTO,
    STOPACTION
};

enum PTZ_PRESET_TYPE
{
    SET_PRESET = 8,
    CLE_PRESET = 9,
    GOTO_PRESET = 39
};

typedef enum
{
	AJ_OVERLAY_STYLE_BLACK_WHITE = 0,		//黑字白底
	AJ_OVERLAY_STYLE_WHITE_BLACK = 1,		//白字黑底
	AJ_OVERLAY_STYLE_TRANSPARENT_BLACKWHITE = 2,	//透明背景，黑字白框
	AJ_OVERLAY_STYLE_TRANSPARENT_WHITEBLACK = 3,	//透明背景，白字黑框
}AjOsdOverlayStyle;

typedef enum
{
	POSITION_TYPE_BY_FOUR_CORNER = 0,//四角
	POSITION_TYPE_BY_SCALE = 1,	//画面比例(0-100)
}Positiontype;

typedef	enum
{
	TYPE_TYPE_BY_TEXT = 0,//文本
	TYPE_TYPE_BY_BMP = 1,	//BMP图片
}Titletype;



//告警结构体
typedef struct _ALARM_TIME
{
    int year;
    int month;
    int day;
    int wday;
    int hour;
    int minute;
    int second;
}ALARM_TIME;

typedef struct
{
    ALARM_TIME	time;
    AJ_ALARM_CODE code;
    int 		flag;
    int			level;
    char 		data[128];
} ALARM_ENTRY;
#define ALARM_ITEM ALARM_ENTRY


typedef struct _VIDEO_STREAM_PARAM
{
    char codec[256];
    int width;
    int height;
    int colorbits;
    int framerate;
    int bitrate;
    char vol_data[256];
    int vol_length;
}VIDEO_PARAM;

typedef struct  _AUDIO_STREAM_PARAM
{
    char codec[256];
    int samplerate;
    int bitspersample;
    int channels;
    int framerate;
    int bitrate;
}AUDIO_PARAM;

typedef struct  _STREAM_AV_PARAM
{
    unsigned char	ProtocolName[32];
    short  bHaveVideo;//0 表示没有视频参数
    short  bHaveAudio;//0 表示没有音频参数
    VIDEO_PARAM videoParam;//视频参数
    AUDIO_PARAM audioParam;//音频参数
    char		szUrlInfo[512];//注意长度
}STREAM_AV_PARAM;

typedef struct
{
    int		bIsKey;
    double	timestamp;
    void    *pUserData;
}FRAME_EXTDATA,* LPFRAME_EXTDATA;


#define PLATFORM_DEFAULT_VALUE 1

#include <time.h>

#ifndef PLATFORM_HI35XX
#define PLATFORM_HI35XX PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_HI3516A
#define PLATFORM_HI3516A PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_HI3518EV200
#define PLATFORM_HI3518EV200 PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_HI3516CV300
#define PLATFORM_HI3516CV300 PLATFORM_DEFAULT_VALUE
#endif


#ifndef PLATFORM_DM365
#define PLATFORM_DM365 PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_AMBAR_S2L
#define PLATFORM_AMBAR_S2L PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_AMBAR_S2LM
#define PLATFORM_AMBAR_S2LM PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_AMBAR_S2LM2
#define PLATFORM_AMBAR_S2LM2 PLATFORM_DEFAULT_VALUE
#endif

#ifndef PLATFORM_MSTAR
#define PLATFORM_MSTAR PLATFORM_DEFAULT_VALUE
#endif


#ifndef PLATFORM_X86
#define PLATFORM_X86 0
#endif

#define VIDEO_PRIVATE_HEADER_MAGIC 0x1a2b3c4d


#define MAX_USER_SESSION_COUNT 		20
#define MAX_USER_SESSION			40
#define MAX_SESSION_TIMEOUT_SECOND	2400

#define MAX_IP_NAME_LEN 64


#define GROUP_NAME_MAX_LEN 32
typedef struct
{
	char groupName[GROUP_NAME_MAX_LEN];
}Group;

#define ACCOUNT_STATUS_MAX_LEN 8
#define ACCOUNT_NAME_MAX_LEN 40
#define ACCOUNT_PASSWORD_MAX_LEN  40

typedef struct
{
	char 	userName[ACCOUNT_NAME_MAX_LEN];
	char 	password[ACCOUNT_PASSWORD_MAX_LEN];
	Group 	group;
	char    status[ACCOUNT_STATUS_MAX_LEN];
}UserAccount;

#define MAX_ACCOUNT_COUNT 10

typedef struct
{
	int count;
	UserAccount accounts[MAX_ACCOUNT_COUNT];
}UserConfig;

typedef struct
{
	char  				serverIP[MAX_IP_NAME_LEN];
	unsigned short  	serverPort;
	unsigned int  		refreshInterval;
}NTPConfig;

#define TIME_MODE_MAX_LEN 32
#define TIME_MODE_NAME_NTP  "NTP"
#define TIME_MODE_NAME_MANUAL "MANUAL"
#define TIME_MODE_NAME_P2P  "P2P"

typedef struct
{
	char modeName[TIME_MODE_MAX_LEN];
}TimeMode;

typedef struct
{
	unsigned char nEnable;			//启用标记
	unsigned char bAuto;			//根据时区自动配置
	short nOffsetMin;		//偏移时间(分钟)
	unsigned char nStartMonth;
	unsigned char nStartWeek;		//该月第几周
	unsigned char nStartWeekday;	//周几
	unsigned char nStartHour;		//小时
	unsigned char nToMonth;
	unsigned char nToWeek;		//该月第几周
	unsigned char nToWeekday;	//周几
	unsigned char nToHour;		//小时
}SummerTimeConfig;

typedef struct
{
	TimeMode  	timeMode;
	int 	  	timeZone;
	NTPConfig 	ntpConfig;
	SummerTimeConfig summerConfig;
}TimeConfig;

typedef struct _TIME_MANUAL_CONFIG
{
	char	time[128];	//时间格式为yyyyMMdd HH:mm:ss
	int		timeZone;  //时区，时区a对应的计算公式为(12+a)*60,其中,a为-12至+12
}TimeManualConfg;

#define PTZ_PROTOCOL_NAME_MAX_LEN 32
typedef struct
{
	char protocolName[PTZ_PROTOCOL_NAME_MAX_LEN];
}PTZProtocol;


#define VERIFY_NAME_MAX_LEN 32
typedef struct
{
	char verifyName[VERIFY_NAME_MAX_LEN];
}Verify;


#define FLOW_CONTROL_MAX_LEN 32
typedef struct
{
	char flowControlName[FLOW_CONTROL_MAX_LEN];
}FlowControl;

#define PTZ_FUNCTION_TYPE_MAX_LEN 28

typedef struct
{
	char typeName[PTZ_FUNCTION_TYPE_MAX_LEN];
}PTZFunctionType;

#define PTZ_FUNCTION_NAME_MAX_LEN 32

typedef struct
{
	char functionName[PTZ_FUNCTION_NAME_MAX_LEN];
	int  presetNum;
	PTZFunctionType functionType;
	int reserveValue;
}PTZFunction;


#define MAX_PTZFUCTION_COUNT 64
typedef struct
{
	int functionCnt;
	PTZFunction functions[MAX_PTZFUCTION_COUNT];
}PTZAdvanceConfig;


typedef struct
{
	PTZProtocol  		ptzProtocol;
	unsigned  int 		comPort;
	unsigned  int 		baudrate;
	unsigned  int 		dataBits;
	unsigned  int 		stopBits;
	Verify 		 		verify;
	FlowControl  		flowControl;
	unsigned int 		bootAction;
}PTZCommonConfig;


typedef struct
{
	PTZCommonConfig    commonCfg;
	PTZAdvanceConfig    advanceCfg;
}PTZConfig;

#define FTP_NAME_MAX_LEN 128
#define FTP_PASSWORD_MAX_LEN 128
#define FTP_PATH_MAX_LEN 256


#define SMTP_NAME_MAX_LEN			128
#define SMTP_PASSWORD_MAX_LEN		128
#define SMTP_ACCOUNT_MAX_LEN		256
#define SMTP_SUBJECT_MAX_LEN        256


#define LOG_LEVEL_NAME_MAX_LEN 200
typedef struct
{
	char levelName[LOG_LEVEL_NAME_MAX_LEN];
}LogLevel;

#define STORE_MEDIA_NAME_MAX_LEN 32

typedef struct
{
	char mediaName[STORE_MEDIA_NAME_MAX_LEN];
}StoreMedia;

#define STORE_POLICY_NAME_MAX_LEN 32

typedef struct
{
	char policyName[STORE_POLICY_NAME_MAX_LEN];
}StorePolicy;

#define BACKUP_WAY_NAME_MAX_LEN 32

typedef struct
{
	char wayName[BACKUP_WAY_NAME_MAX_LEN];
}BackupWay;

#define SYSLOG_FILE_NAME_MAX_LEN   32

typedef struct
{
	LogLevel   			logLevel;
	unsigned int	 	maxDays;
	//unsigned int   		maxEventPerday;
	StoreMedia   		storeMedia;
	StorePolicy   		storePolicy;
	int   				autoBackup; // 1  for auto  0 for manual
	BackupWay   		backupWay;
}SyslogConfig;


#define MAX_LANGUAGE_LEN 32

typedef struct
{
	char language[MAX_LANGUAGE_LEN];
}MiscConfig;

typedef struct
{
	int hour;
	int minute;
	int sec;
}DayTime;

typedef struct
{
	int enable;
	int day; //0: erverday, 1: monday,-- 7: sunday
	DayTime time;
}MaintainConfig;

#define MAX_ALOW_IP_NUM 5
typedef struct
{
	int enable;
	unsigned int nAllowIp[MAX_ALOW_IP_NUM];
}SysAlowIpConfig;


#define MAX_ALARM_CLOCK_NUM 5
typedef struct
{
	unsigned char enable;
	unsigned char hour;
	unsigned char minute;
	unsigned char second;
}AlarmClock;//闹钟设置

typedef struct
{
	unsigned char enable;
	unsigned char from_hour;
	unsigned char from_minute;
	unsigned char from_second;
	unsigned char to_hour;
	unsigned char to_minute;
	unsigned char to_second;
	unsigned char reserved;
}AlarmOClock;//整点报时

typedef struct
{
	AlarmOClock oclock;
	AlarmClock alarmclock[MAX_ALARM_CLOCK_NUM];
}AlarmClockConfig;

typedef struct
{
	PTZConfig     ptzCfg;
	TimeConfig    timeCfg;
	UserConfig    userCfg;
	SyslogConfig  syslogCfg;
	MiscConfig	  miscCfg;
	MaintainConfig maintainCfg;
	SysAlowIpConfig alowipCfg;
#if PLATFORM_MSTAR	| PLATFORM_HI35XX
	AlarmClockConfig clockSetting;//闹钟设置
#endif
}SystemConfig;

// media config

#define TIME_FORMAT_MAX_LEN 32

typedef struct
{
	char format[TIME_FORMAT_MAX_LEN];
}TimeFormat;

typedef struct
{
	int posX;//当posType=POSITION_TYPE_BY_FOUR_CORNER时，只能是0/1/2。否则为比例0-100%
	int posY;//当posType=POSITION_TYPE_BY_FOUR_CORNER时，只能是0/1/2。否则为比例0-100%
	TimeFormat timeFormat;
	Positiontype posType;
}TimeOverlay;

#define TITLE_MAX_LEN 200
typedef struct
{
	int posX;	//当posType=POSITION_TYPE_BY_FOUR_CORNER时，只能是0/1/2。否则为比例0-100%
	int posY;	//当posType=POSITION_TYPE_BY_FOUR_CORNER时，只能是0/1/2。否则为比例0-100%
	char title_utf8[TITLE_MAX_LEN];//当titleType=BMP时，这里存放BMP路径
	Positiontype posType;
	Titletype titleType;
}TitleOverlay;

typedef struct
{
	int enable;
	int transparency; //titleFormatEn。叠加信息
	TimeOverlay timeOverlay;
	TitleOverlay titleOverlay;
	short style;	//AjOsdOverlayStyle
	short bDsplayWeek;	//0 1 是否显示星期几
	short bOverlayFps;
	short fontsize; // 0 标准  1 大字体 2 超大字体
	int real_transparency; //透明度。0-100
}VideoOverlay;

#define RESOLUTION_NAME_MAX_LEN 32

typedef struct
{
	char name[RESOLUTION_NAME_MAX_LEN];
}Resolution;

#define VIDEO_ENCODE_FORAMT_MAX_LEN 32
typedef struct
{
	char name[VIDEO_ENCODE_FORAMT_MAX_LEN];
}VideoEncodeFormat;


#define BITRATE_CONTROL_MAX_LEN 32
typedef struct
{
	char name[BITRATE_CONTROL_MAX_LEN];
}BitRateControl;

typedef struct
{
	int lbr_enable;
	int lbr_style;		//低码率模式:	0: 保持帧率,自动码率	1: 视频质量优先,自动丢帧
	int lbr_bitratemode;//码率控制:	0: 自动 1:手动
	int lbr_bitrate;		//低码率目标值
	int lbr_motionlevel;	//运动级别:	0: 静止 1:运动幅度小 2:运动幅度大
	int lbr_noicelevel;	//噪点级别:	0: 无 1:低 2:高
}LbrControl;

typedef struct
{
	int enable;
	int streamID;
	Resolution   resolution;
	VideoEncodeFormat encodeFormat;
	BitRateControl bitRateControl;
	int initQuant;
	int bitRate;
	int frameRate;
	int display_frameRate;

#if (PLATFORM_AMBAR_S2L|PLATFORM_AMBAR_S2LM | PLATFORM_AMBAR_S2LM2)
	LbrControl lbrConfig;
#endif
}VideoEncodeCfg;

typedef struct
{
	int enable;
	int stream;
	int quality;
	int framerate;
}JpegEncodeCfg;

#define VIDEO_NUMBER_MAX 3 //定义视频流数量

typedef struct
{
	VideoEncodeCfg encodeCfg[VIDEO_NUMBER_MAX];
	//encode profile, 0: default, 1: baseprofile
	int encode_profile;
	int disable_private_data; //0: enalbe, 1: disable
#if (PLATFORM_AMBAR_S2L|PLATFORM_AMBAR_S2LM | PLATFORM_AMBAR_S2LM2)
	int encode_mode;//0,4
	int noice_level;//0-10
#endif
}VideoEncode;

#define VIDEO_FORMAT_MAX_LEN 32

typedef struct
{
	char name[VIDEO_FORMAT_MAX_LEN];
}VideoFormat;

typedef struct
{
	int shutter_mode;//0-1	//快门模式:自动/手动
	short shutter_speed_day;//10-10000	//快门速度
	short shutter_speed_night;//10-10000 //快门速度
}VideoShutter;

typedef enum
{
	IRCUT_Mode_Active = 0, //主动模式/自动模式, ISP自动判断SENSOR增益，控制IRCUT和灯板
	IRCUT_Mode_DayNight =1, //日夜模式，根据时间段来控制IRCUT和图像彩转灰
	IRCUT_Mode_Passive = 2,	//被动模式/外部控制，根据灯板的光敏电阻给的硬件信号，来控制IRCUT
	IRCUT_Mode_Manual = 3,	//手动模式，不根据灯板和SENSOR增益，由调用者来手动切换
	IRCUT_Mode_ReversePassive =	4, //反向被动模式
}IRCutMode;

typedef enum
{
	LED_PURE_INFRAED = 0, //纯红外
	LED_PURE_WHITE = 1, //纯白光
	LED_INFRAED_THEN_WHITE = 2, //红外触发时白光
	LED_WHITE_THEN_INFRAED = 3, //白光触发时红外
}LedMode;

typedef enum
{
	ISP_NORMAL = 0,// 正常
	ISP_FACE_EXPOSURE_PREVENTION =1,//防人脸过曝
	ISP_CHEPAI_MODE=2,//: 照车牌模式
}IspAdvMode;

typedef struct
{
	DayTime startTime;
	DayTime endTime;
}DayTimeSpan;

typedef struct
{
	int brightness;
	int contrast;
	int saturation;
	int sharpness;
	int tvsystem; // 0: NTSC (60HZ) 1: PAL (50HZ)
	int hflip;		//水平翻转 0 1
	int vflip;		//垂直翻转 0 1
	int rotate;		//走廊模式 0 1
	int whitebalance;	//enable R G B 4个值组合  //enable=(whitebalance>>24)&0xff; R=(whitebalance>>16)&0xff; G=(whitebalance>>8)&0xff; B=(whitebalance)&0xff
	int backlight;		//背光(逆光补偿0-255)
	int HLC;	//强光抑制 //0-255
	int tnf;	//2d降噪 //0-255
	int snf;	//3D降噪 //0-255
	IRCutMode ircut_mode;
	int ircut_sensitivity; //0 to 20
	DayTimeSpan ircut_nighttime;
	int ircut_keepcolor; //20120419
	int bManualGain;//0: 自动增益 1: 手动增益
	int gainValue;//手动增益值
	int wdr_mode; //0: disable, 1: always open, 2: open at work time
	DayTimeSpan wdr_worktime;
#if 1//PLATFORM_HI35XX| PLATFORM_HI3516A | PLATFORM_HI3518EV200|PLATFORM_MSTAR |PLATFORM_HI3516CV300
	int wdr_value;
	int dfrog_flag;
	int dfrog_value;
#endif
#if 1//PLATFORM_HI3516A | PLATFORM_HI35XX|PLATFORM_HI3516CV300 |PLATFORM_AMBAR_S2L|PLATFORM_AMBAR_S2LM | PLATFORM_AMBAR_S2LM2
	VideoShutter shutterSetting;
#endif
	int isp_mode_color;	//ISP彩色模式 0-3
	int isp_mode_night; //ISP夜间模式 0-3
	LedMode led_mode;
	IspAdvMode ispadvmode;//0: 正常 1: 防人脸过曝 2: 照车牌模式
}VideoCapture;

#define MAX_VIDEO_MASK_AREA 4
typedef struct
{
	int xPos;
	int yPos;
	int width;
	int height;
}MASK_AREA_ENTRY;

typedef struct
{
	MASK_AREA_ENTRY mainStreamMaskList[MAX_VIDEO_MASK_AREA];
	MASK_AREA_ENTRY subStreamMaskList[MAX_VIDEO_MASK_AREA];
}VideoMaskConfig;


#define MAX_VIDEO_ROI_AREA 4
typedef struct
{
	int xPos;
	int yPos;
	int width;
	int height;
}ROI_AREA_ENTRY;

typedef struct
{
	int enable;
	ROI_AREA_ENTRY roi[MAX_VIDEO_ROI_AREA];
}VideoROI;

typedef struct
{
	VideoCapture   videoCapture;
	VideoEncode    videoEncode;
	JpegEncodeCfg  jpegCfg;
	VideoOverlay   overlay;

	VideoMaskConfig videoMask;
	VideoROI		roiCfg;
}VideoConfig;

typedef struct
{
	int channels;
	int bitspersample;
	int samplerate;
	short volume_capture;
	short volume_play;
	int amplify;	//是否需要内部功放
	int ra_answer;//反向音频是否需要按键接听
}AudioCapture;
#define AUDIO_ENCODE_TYPE_MAX_LEN 32

typedef struct
{
	char typeName[AUDIO_ENCODE_TYPE_MAX_LEN];
}AudioEncodeType;

typedef struct
{
	int enable;
	int sampleRate;
	AudioEncodeType   audioEncodeType;
	int bitRate;
}AudioEncode;

typedef struct
{
	AudioCapture  audioCapture;
	AudioEncode   audioEncode;
}AudioConfig;

typedef struct
{
	VideoConfig   videoConfig;
	AudioConfig   audioConfig;
}MediaConfig;

typedef struct
{
	int index;
	char  serverIP[MAX_IP_NAME_LEN];
	int serverPort;
	char userName[FTP_NAME_MAX_LEN];
	char password[FTP_PASSWORD_MAX_LEN];
	char filePath[FTP_PATH_MAX_LEN];
	int fileSize;
}FtpServer;

typedef struct
{
	int index;
	char toMail[SMTP_ACCOUNT_MAX_LEN];
	char ccMail[SMTP_ACCOUNT_MAX_LEN];
	char subject[SMTP_SUBJECT_MAX_LEN];
}SmtpServer;

enum
{
	//FTP_INDEX_FOR_RECORD_UPLOAD,
			FTP_INDEX_FOR_ALARM_UPLOAD,
	FTP_INDEX_FOR_LOG_BACKUP,
	FTP_INDEX_FOR_CONFIG_BACKUP,
	FTP_INDEX_FOR_UPDATE,
	FTP_SERVER_COUNT
};

enum
{
	//SMTP_INDEX_FOR_RECORD_UPLOAD,
			SMTP_INDEX_FOR_ALARM_UPLOAD,
	SMTP_INDEX_FOR_LOG_BACKUP,
	SMTP_INDEX_FOR_CONFIG_BACKUP,
	SMTP_SERVER_COUNT
};

//#define FTP_SERVER_COUNT 5

typedef struct
{
	FtpServer ftpServers[FTP_SERVER_COUNT];
}FtpServerList;

//#define SMTP_SERVER_COUNT 4

typedef struct
{
	char  	   		serverIP[MAX_IP_NAME_LEN];
	unsigned  int 	serverPort;
	int             auth;
	char 			userName[SMTP_NAME_MAX_LEN];
	char 			password[SMTP_PASSWORD_MAX_LEN];
	char 			fromMail[SMTP_ACCOUNT_MAX_LEN];
	SmtpServer 		smtpServers[SMTP_SERVER_COUNT];
}SmtpServerList;

typedef struct
{
	FtpServer  ftpServers[FTP_SERVER_COUNT];
	SmtpServerList   smtpServers;
}ServerConfig;

typedef struct
{
	short enable;
	unsigned short Port;
	unsigned int Ip;
}MulticastStruct;

typedef struct
{
	short rtsp_auth;
	short onvif_auth;
	int videoPort;
	int rtpoverrtsp;
	int ptzPort;
	int webPort;
	MulticastStruct StreamMulticast[2];
}StreamAccessConfig;

typedef struct
{
	StreamAccessConfig  streamAccess;
}MediaStreamConfig;


typedef struct
{
	int			enable;
	char			server[MAX_IP_NAME_LEN];
	unsigned short  port;
	char username[ACCOUNT_NAME_MAX_LEN];
	char password[ACCOUNT_PASSWORD_MAX_LEN];
	unsigned short PlayTone;//启动播放声音
	unsigned short reserved;
}VmPlatformConfig;

typedef struct
{
	VmPlatformConfig cfg;
}PlatformConfig;

#define PLATFORM_REGISGER_RESULT_FILE "/tmp/flag_plat_reg_result"
typedef enum
{
	PLAT_REG_RESULT_REG_NO = 0,
	PLAT_REG_RESULT_REGGING,
	PLAT_REG_RESULT_REG_FAILED,
	PLAT_REG_RESULT_REG_OK,
}PlatRegStatus;
typedef struct
{
	PlatRegStatus result;	//0: 未注册 1: 注册中 2: 注册失败 3: 注册成功
	char szPlatDevId[32];
	char reservedInfo[128];
}PlatRegResult;

#define GB28181_ID_MAX_LEN 32
#define GB28181_IP_MAX_LEN 32
#define GB28181_NAME_MAX_LEN 64
#define GB28181_PWD_MAX_LEN 32
typedef struct
{
	int enable;
	int nstreams;		//可用码流:0 主码流 1子码流 2 双码流
	int nChannelNum;	//通道数量

	char hcId[GB28181_ID_MAX_LEN];
	char hcIp[GB28181_IP_MAX_LEN];
	char hcName[GB28181_NAME_MAX_LEN];
	char hcPwd[GB28181_PWD_MAX_LEN];
	int hcPort;

	char lcId[GB28181_ID_MAX_LEN];
	char lcName[GB28181_NAME_MAX_LEN];
	char lcPwd[GB28181_PWD_MAX_LEN];
	int lcPort;

	char camId[GB28181_ID_MAX_LEN];
	char alarmId[GB28181_ID_MAX_LEN];
}GB28181Config;


#define RECORD_FILEFORMAT_MAX_LEN 32

typedef struct
{
	char formatName[RECORD_FILEFORMAT_MAX_LEN];
}RecordFileFormat;

#define RECORD_MEDIA_TYPE_MAX_LEN 32
typedef struct
{
	char typeName[RECORD_MEDIA_TYPE_MAX_LEN];
}RecordMediaType;

#define RECORD_STORAGE_POLICY_MAX_LEN 32
typedef struct
{
	char policyName[RECORD_STORAGE_POLICY_MAX_LEN];
}RecordStoragePolicy;


#define MAX_DAYTIMESPAN_COUNT 24

typedef struct
{
	int workday;
	int timeSpancnt;
	DayTimeSpan timeSpans[MAX_DAYTIMESPAN_COUNT];
}WorkDayTime;


#define MAX_WORDDAYTIME_COUNT 8
typedef struct
{
	int workdayCnt;
	WorkDayTime workdayTimes[MAX_WORDDAYTIME_COUNT];
}TimeSpanList;

#define MAX_STORAGE_SEQUENCE_NAME_LEN 256
#define MAX_REMOTE_MOUNT_PARAM_LEN 256

typedef enum
{
	NETWORK_STORAGE_DISABLE=0,
	NETWORK_STORAGE_TYPE_NFS=1,
}NetworkStorageType;

typedef struct
{
	int		localEnable;
	NetworkStorageType		remoteEnable;
	char    storageSequence[MAX_STORAGE_SEQUENCE_NAME_LEN];
	char    mountParam[MAX_REMOTE_MOUNT_PARAM_LEN];
	RecordStoragePolicy storePolicy;
	short timelapseEnable;
	short recordFileSize;
	int recordFileKeeyDays;//录像保留最大天数
}RecordCommConfig;

typedef struct
{
	int					stream; // 1:主码流 2:子码流 3:主码流JPG 4:子码流JPG 5:双码流录像  	6:录像+抓图(主码流)    7:录像+抓图(子码流) 8: 双码流录像+抓拍
	RecordFileFormat	fileFormat;
	RecordMediaType		mediaType;
	int					localStore;
	int					remoteStore;
	TimeSpanList		timeSpanList;

	int 				jpgInterval;
	int					ftpUpload;
	int					emailUpload;
}ScheduleRecordConfig;

typedef struct
{
	int					stream; // 0:主码流 1:子码流 2:主子码流同时录像
	RecordFileFormat	fileFormat;
	RecordMediaType		mediaType;
	int 				precordTime;
	int 				recordTime;
	int					localStore;
	int					remoteStore;
	int					ftpUpload;
	int					emailUpload;
	int 				stopNoAlarm; //if noalarmstop=1, recordTime means the record time after alarm disappear
}AlarmRecordConfig;

typedef struct
{
	short preTakeTime;
	short sendoutInterval;//FTP/EMAIL发送频率,秒.0标识不控制
	int totalTakeTime;
	int localStore;
	int remoteStore;
	int ftpUpload;
	int emailUpload;
	int 	stopNoAlarm; //if noalarmstop=1, recordTime means the record time after alarm disappear
	int	stream;	//抓图使用的码流
}AlarmCaptureConfig;

typedef struct
{
	RecordCommConfig		commonCfg;
	ScheduleRecordConfig	scheduleRecordCfg;
	AlarmRecordConfig   motionRecordCfg;
	AlarmCaptureConfig  motionCaptureCfg;
	AlarmRecordConfig   inputAlarmRecordCfg;
	AlarmCaptureConfig  inputAlarmCaptureCfg;
	//20120904
	AlarmRecordConfig   linkdownRecordCfg;
	AlarmCaptureConfig  linkdownCaptureCfg;
}RecordConfig;

#define MAX_PTZPOSITION_COUNT 20

typedef struct
{
	int positionIndex;
}PTZPosition;

typedef struct
{
	PTZPosition  postion;
}PositionPreset;

typedef struct
{
	int interval;
	int duration;
	int positionCount;
	PTZPosition ptzPositions[MAX_PTZPOSITION_COUNT];
}PositionLoop;

typedef struct
{
	int interval;
	int walkCount;
	int positionCount;
	PTZPosition ptzPositions[MAX_PTZPOSITION_COUNT];
}PositionWalk;

#define PTZ_ACTION_TYPE_MAX_LEN 32
typedef  struct
{
	char actionName[PTZ_ACTION_TYPE_MAX_LEN];
}PTZActionType;

typedef struct
{
	int enable;
	PTZActionType actionType;
	union Action
	{
		PositionPreset preset;
		PositionLoop  loop;
		PositionWalk  walk;
	}action;
}PTZAction;


#define TRIGGER_TYPE_NAME_MAX_LEN 32
typedef struct
{
	char name[TRIGGER_TYPE_NAME_MAX_LEN];
}TriggerType;

#define CHANNEL_TYPE_NAME_MAX_LEN 32
typedef struct
{
	char name[CHANNEL_TYPE_NAME_MAX_LEN];
}ChannelType;

typedef struct
{
	int enable;
	int portIndex;
	ChannelType channelType;
	TriggerType triggerType;
	int duration;
}AlarmOutputAction;

#define AUDIO_ACTION_LEN_FILENAME 128
typedef struct
{
	int enable;
	int times;//播放次数 <=0表示一直播。大于0表示次数
	char filename[AUDIO_ACTION_LEN_FILENAME];
}AudioPlayAction;


typedef struct
{
	AlarmOutputAction outputAction;
	PTZAction         ptzAction;
	AudioPlayAction	  audioAction;
}InputAction;

typedef struct
{
	int enable;
	int portIndex;
	ChannelType		channelType;
	TriggerType		triggerType;
	TimeSpanList	timeSpanList;
	InputAction		alarmAction;
}AlarmChannel;

#define MAX_ALARMCHANNEL_COUNT 4

typedef struct
{
	int channelCnt;
	AlarmChannel alarmChannels[MAX_ALARMCHANNEL_COUNT];
}InputAlarm;

typedef struct
{
	AlarmOutputAction outputAction;
	PTZAction         ptzAction;
	AudioPlayAction	  audioAction;
}MotionDetectAction;

typedef struct
{
	int enable_babycry;//婴儿哭声
	int sensity_babycry;
	int enable_lsd;	//高分贝声音
	int sensity_lsd;
}AudioAlarm;

#if (PLATFORM_AMBAR_S2L|PLATFORM_AMBAR_S2LM | PLATFORM_AMBAR_S2LM2|PLATFORM_HI35XX|PLATFORM_MSTAR| PLATFORM_HI3516A | PLATFORM_HI3518EV200 |PLATFORM_HI3516CV300)
#define MD_MAX_GRID_ROW 18
#define MD_MAX_GRID_COL 22
#define MD_CONFIG_STRING_LEN (MD_MAX_GRID_ROW*MD_MAX_GRID_COL+4)
#define MAX_MOTIONDETECT_CONFIG_STRING MD_CONFIG_STRING_LEN//32
#else
#define MD_MAX_GRID_ROW 4
#define MD_MAX_GRID_COL 4
#define MD_CONFIG_STRING_LEN (MD_MAX_GRID_ROW*MD_MAX_GRID_COL+4)
#define MAX_MOTIONDETECT_CONFIG_STRING 32
#endif

//移动侦测组定义，左上、右下角block位置
typedef struct
{
	int left;
	int top;
	int right;
	int bottom;
}MdGroupConfig;

typedef struct
{
	int enable;
	TimeSpanList  timeSpanList;
	int blockCount; // high word for row , low  word for column;
	char blockCfg[MAX_MOTIONDETECT_CONFIG_STRING]; // ''\0' terminate
	int sensitivity;
	int alarmThreshold;
	int dayNightSwitch;
	int nightSensitivity;
	int nightAlarmThreshold;
	DayTimeSpan nightTime;
	MotionDetectAction alarmAction;
}MotionDetectAlarm;

typedef struct
{
	AlarmOutputAction outputAction;
}VideoLostAction;

typedef struct
{
	int enable;
	TimeSpanList  timeSpanList;
	VideoLostAction alarmAction;
}VideoLostAlarm;

typedef struct
{
	AlarmOutputAction outputAction;
}VideoCoverAction;

typedef struct
{
	int enable;
	TimeSpanList		timeSpanList;
	VideoCoverAction	alarmAction;
}VideoCoverAlarm;

typedef struct
{
	AlarmOutputAction outputAction;
}StorageFullAction;

typedef struct
{
	int enable;
	int threshold;
	StorageFullAction alarmAction;
}StorageFullAlarm;

typedef struct
{
	int x0Pos;
	int y0Pos;
	int x1Pos;
	int y1Pos;
}VideoLineStruct;
typedef struct
{
	AlarmOutputAction outputAction;
	AudioPlayAction	  audioAction;
}VideoGateAction;

#define MAX_VIDEO_VG_LINE	2
typedef struct
{
	int enable;
	int sensitivity;
	VideoLineStruct data[MAX_VIDEO_VG_LINE];

	VideoGateAction alarmAction;
}VideoGateAlarm;


typedef struct
{
	InputAlarm			inputAlarm;
	MotionDetectAlarm   motionDetectAlarm;
	VideoLostAlarm		videoLostAlarm;
	VideoCoverAlarm		videoCoverAlarm;
	StorageFullAlarm	storageFullAlarm;
	AudioAlarm 			audioAlarm;
	VideoGateAlarm		vgAlarm;
}AlarmConfig;

/*
typedef struct
{
	char  IPAddress[MAX_IP_NAME_LEN];
	char  netMask[MAX_IP_NAME_LEN];
	char  gateWay[MAX_IP_NAME_LEN];
	char  DNS1[MAX_IP_NAME_LEN];
	char  DNS2[MAX_IP_NAME_LEN];
}StaticIPConfig;

typedef struct
{
	char reserved[16];
}DHCPConfig;

typedef struct
{
	int enable;
	int interval;
}ADSLAutoConnect;

typedef struct
{
	char IPAddress[MAX_IP_NAME_LEN];
	char netMask[MAX_IP_NAME_LEN];
	char gateWay[MAX_IP_NAME_LEN];
}ADSLLanConfig;

#define ADSL_NAME_MAX_LEN 32
#define ADSL_PASSWORD_MAX_LEN 32

typedef struct
{
	char userName[ADSL_NAME_MAX_LEN];
	char password[ADSL_PASSWORD_MAX_LEN];
	ADSLAutoConnect autoConnect;
	ADSLLanConfig   adslLanCfg;
}ADSLConfig;

*/

#define MAX_WEPENCRYPT_AUTHMODE_NAME_LEN 64
#define MAX_WEPENCRYPT_ENCRYPTTYPE_NAME_LEN 64
#define MAX_WEPENCRYPT_KEYMODE_NAME_LEN 64
#define MAX_WEPENCRYPT_KEYVALUE_LEN 64

#define WEPENCRYPT_AUTHMODE_NAME_OPENSYSTEM "open system"
#define WEPENCRYPT_AUTHMODE_NAME_SHAREDKEY "shared key"

#define WEPENCRYPT_AUTHMODE_VALUE_OPENSYSTEM 0
#define WEPENCRYPT_AUTHMODE_VALUE_SHAREDKEY 1
#define WEPENCRYPT_AUTHMODE_VALUE_UNKNOWN -1

typedef struct
{
	char authMode[MAX_WEPENCRYPT_AUTHMODE_NAME_LEN];
	char encryptType[MAX_WEPENCRYPT_ENCRYPTTYPE_NAME_LEN];
	char keyMode[MAX_WEPENCRYPT_KEYMODE_NAME_LEN];
	char keyValue[MAX_WEPENCRYPT_KEYVALUE_LEN];
	int  keyIndex;
}WepEncrypt;


#define MAX_WPAENCRYPT_ENCRYPTTYPE_NAME_LEN 64
#define MAX_WPAENCRYPT_AUTHMODE_NAME_LEN 64
#define MAX_WPAENCRYPT_KEYVALUE_LEN 64

#define WPAENCRYPT_ENCRYPTTYPE_NAME_TKIP  "tkip"
#define WPAENCRYPT_ENCRYPTTYPE_NAME_AES   "aes"

typedef struct
{
	char encryptType[MAX_WPAENCRYPT_ENCRYPTTYPE_NAME_LEN];
	char authMode[MAX_WPAENCRYPT_AUTHMODE_NAME_LEN];
	char keyValue[MAX_WPAENCRYPT_KEYVALUE_LEN];
}WpaEncrypt;

#define MAX_WIRELESSENCRYPT_ENCRYPTTYPE_NAME_LEN 64
#define WIRELESSENCRYPT_ENCRYPTTYPE_NAME_WEP  "wep"
#define WIRELESSENCRYPT_ENCRYPTTYPE_NAME_WPA  "wpa"


typedef struct
{
	int enable;
	char encryptType[MAX_WIRELESSENCRYPT_ENCRYPTTYPE_NAME_LEN];
	WepEncrypt  wepEncrypt;
	WpaEncrypt  wpaEncrypt;
}WirelessEncrypt;


#define MAC_ADDRESS_LEN   18    //00:11:11:11:11:11
#define MAX_WIRELESS_OPERATIONMODE_NAME_LEN 32
#define MAX_WIRELESS_MACMODE_NAME_LEN 64
#define MAX_WIRELESS_ESSID_NAME_LEN 64
#define MAX_WIRELESS_REGION_NAME_LEN 64
#define MAX_WIRELESS_BITRATE_NAME_LEN 10
#define MAX_WIFI_VERSION_LEN 10

#define WIRELESS_OPERATIONMODE_MASTER_NAME "master"
#define WIRELESS_OPERATIONMODE_MANAGED_NAME "managed"

#define WIRELESS_MACMODE_NAME_A "A"
#define WIRELESS_MACMODE_NAME_B "B"
#define WIRELESS_MACMODE_NAME_G "G"
#define WIRELESS_MACMODE_NAME_MIXED "MIXED"

#define WIRELESS_MACMODE_VALUE_A  4
#define WIRELESS_MACMODE_VALUE_B  3
#define WIRELESS_MACMODE_VALUE_G  2
#define WIRELESS_MACMODE_VALUE_MIXED  1
#define WIRELESS_MACMODE_VALUE_UNKNOWN   -1


#define WIRELESS_REGION_NAME_TAIWAN "TAIWAN"
#define WIRELESS_REGION_NAME_USA "USA"
#define WIRELESS_REGION_NAME_FRANCE "FRANCE"
#define WIRELESS_REGION_NAME_ISRAEL "ISRAEL"

#define WIRELESS_REGION_VALUE_TAIWAN 2
#define WIRELESS_REGION_VALUE_USA  1
#define WIRELESS_REGION_VALUE_FRANCE  3
#define WIRELESS_REGION_VALUE_ISRAEL  5

#define WIRELESS_REGION_VALUE_UNKNOWN  -1

/*
typedef struct
{
	int enable;
	char operationMode[MAX_WIRELESS_OPERATIONMODE_NAME_LEN];
	char macMode[MAX_WIRELESS_MACMODE_NAME_LEN];
	char bitRate[MAX_WIRELESS_BITRATE_NAME_LEN];
	char essid[MAX_WIRELESS_ESSID_NAME_LEN];
	char region[MAX_WIRELESS_REGION_NAME_LEN];
	int channelNum;
	char MACAddress[MAC_ADDRESS_LEN];
	WirelessEncrypt wirelessEncrypt;
}WirelessConfig;

typedef struct
{
	unsigned char MACAddress[MAC_ADDRESS_LEN];
}WireConfig;
*/

#define MAX_DDNS_SERVER_NAME_LEN 256
#define MAX_DDNS_DOMAIN_NAME_LEN 256
#define MAX_DDNS_USERNAME_LEN 256
#define MAX_DDNS_PASSWORD_LEN 256
typedef struct
{
	int enable;
	char server[MAX_DDNS_SERVER_NAME_LEN];
	char domain[MAX_DDNS_DOMAIN_NAME_LEN];
	char userName[MAX_DDNS_USERNAME_LEN];
	char password[MAX_DDNS_PASSWORD_LEN];
	int freshInterval;
}DDNSConfig;

typedef struct
{
	int enable;
}UPNPConfig;

typedef enum
{
	P2P_TYPE_NOTDEFINED = 0,
	P2P_TYPE_DANALE = 1,
	P2P_TYPE_ANKO = 2,
	P2P_TYPE_GOOLINK = 3,
	P2P_TYPE_YUECAM = 4,
	P2P_TYPE_QQCONNECT = 5,
	P2P_TYPE_TUTK = 6
}P2pType;

typedef struct
{
	int enable;
	int p2ptype;	//
}P2PConfig;


#define ADSL_NAME_MAX_LEN 32
#define ADSL_PASSWORD_MAX_LEN 32

typedef struct
{
	int  enable;
	char userName[ADSL_NAME_MAX_LEN];
	char password[ADSL_PASSWORD_MAX_LEN];
}ADSLConfigNew;

typedef struct
{
	unsigned char   MACAddress[MAC_ADDRESS_LEN];
	short			dhcpEnable;
	short			onvifAllnetEnable;//是否启用ONVIF全网通
	char  IPAddress[MAX_IP_NAME_LEN];
	char  netMask[MAX_IP_NAME_LEN];
	char  gateWay[MAX_IP_NAME_LEN];
	char  DNS1[MAX_IP_NAME_LEN];
	char  DNS2[MAX_IP_NAME_LEN];
}LANConfig;

typedef struct
{
	int enable;
	char address[MAX_IP_NAME_LEN];
	int interval;
	int maxFail;
}WIFIPingWatchConfig;

typedef struct
{
	int enable;
	char version[MAX_WIFI_VERSION_LEN];
	int	dhcpEnable;
	char IPAddress[MAX_IP_NAME_LEN];
	char netMask[MAX_IP_NAME_LEN];
	char gateWay[MAX_IP_NAME_LEN];
	char operationMode[MAX_WIRELESS_OPERATIONMODE_NAME_LEN];
	char macMode[MAX_WIRELESS_MACMODE_NAME_LEN];
	char bitRate[MAX_WIRELESS_BITRATE_NAME_LEN];
	char essid[MAX_WIRELESS_ESSID_NAME_LEN];
	char region[MAX_WIRELESS_REGION_NAME_LEN];
	int channelNum;
	char MACAddress[MAC_ADDRESS_LEN];
	WirelessEncrypt wirelessEncrypt;
	WIFIPingWatchConfig pingWatchCfg;
}WIFIConfig;

typedef struct
{
	int enable;
	char version[MAX_WIFI_VERSION_LEN];
	char IPAddress[MAX_IP_NAME_LEN];
	char netMask[MAX_IP_NAME_LEN];
	char macMode[MAX_WIRELESS_MACMODE_NAME_LEN];
	char bitRate[MAX_WIRELESS_BITRATE_NAME_LEN];
	char essid[MAX_WIRELESS_ESSID_NAME_LEN];
	char region[MAX_WIRELESS_REGION_NAME_LEN];
	int channelNum;
	char MACAddress[MAC_ADDRESS_LEN];
	WirelessEncrypt wirelessEncrypt;
}WIFIApConfig;


#define MAX_DIALNUMBER_LEN  32
#define MAX_APN_STRING		256
#define MAX_CENTER_NUMBER   256

#if 0

#define DIAL_OPTION_MANUAL		0
#define DIAL_OPTION_CALL		1
#define DIAL_OPTION_AUTO		2

#else  //not same as PVT

#define DIAL_OPTION_AUTO		0
#define DIAL_OPTION_CALL		1

#endif

typedef struct
{
	int enable;
	int type;
	char dialNumber[MAX_DIALNUMBER_LEN];
	char apnString[MAX_APN_STRING];
	char userName[ADSL_NAME_MAX_LEN];
	char password[ADSL_PASSWORD_MAX_LEN];
	int  dialOption; //0: manual dial; 1: call dial; 2: auto
	char centerNumber[MAX_CENTER_NUMBER];
	char SMSC[MAX_CENTER_NUMBER];
}G3Config;

#define MAX_VPN_SERVER_NAME_LEN 256
#define MAX_VPN_USERNAME_LEN 256
#define MAX_VPN_PASSWORD_LEN 256
typedef struct
{
	int enable;
	char vpnServerIp[MAX_VPN_SERVER_NAME_LEN];
	char userName[MAX_VPN_USERNAME_LEN];
	char password[MAX_VPN_PASSWORD_LEN];
	int mtu;
}PPTPConfig;

typedef struct
{
	LANConfig		lanCfg;
	WIFIConfig		wifiCfg;
	ADSLConfigNew	adslCfg;
	DDNSConfig		ddnsCfg;
	UPNPConfig		upnpCfg;
	G3Config		g3Cfg;
	PPTPConfig      pptpCfg;
	P2PConfig		p2pCfg;
	WIFIApConfig	wifiApCfg;
}NetworkConfigNew;

typedef struct
{
	AlarmConfig  		alarmCfg;
	SystemConfig		systemCfg;
	MediaConfig 		mediaCfg;
	ServerConfig  		serverCfg;
	MediaStreamConfig 	mediaStreamCfg;
	PlatformConfig		platformCfg;
	RecordConfig  		recordCfg;
//	NetworkConfig 		networkCfg;
	NetworkConfigNew	networkCfgNew;
	GB28181Config		gb28181Cfg;
}GlobalConfig;

typedef struct
{
	int year;
	int month;
	int day;
	int hour;
	int minute;
	int second;
}SYSTEM_TIME;

#define MAX_ALARM_DATA 220//128 //32->128 modified by 20090403

typedef struct
{
	SYSTEM_TIME		alarmtime;
	AJ_ALARM_CODE 	alarmcode;
	int 			alarmflag;
	int				alarmlevel;
	char 			alarmdata[MAX_ALARM_DATA];
} ALARM_MSG_DATA;

typedef struct
{
	char username[ACCOUNT_NAME_MAX_LEN];
	char password[ACCOUNT_PASSWORD_MAX_LEN];
}LOGIN_MSG_DATA;

typedef struct
{
	char username[ACCOUNT_NAME_MAX_LEN];
	char password[ACCOUNT_PASSWORD_MAX_LEN];
	char vendorid[ACCOUNT_PASSWORD_MAX_LEN];
	int	 authmethod;
}LOGIN_MSG_DATA_EX;

typedef struct
{
	char filePath[256];
}CONFIG_UPDATE_MSG_DATA;

typedef struct
{
	char filePath[256];
	unsigned int nPhyAddr;
	unsigned int nFileLen;
}APPBIN_UPDATE_MSG_DATA;

typedef struct
{
	char path[256];
	char fileName[256];
}FIRMWARE_FTP_UPDATE_MSG_DATA;

typedef struct
{
	char fileName[256];
}RECORD_REMOVE_MSG_DATA;

typedef struct
{
	int mounted;
	int total;
	int used;
	int free;
	int percent;
}SDCARD_INFO_DATA;

typedef struct
{
	int mounted;
	int total;
	int used;
	int free;
	int percent;
}USB_INFO_DATA;

typedef struct
{
	int mounted;
	int total;
	int used;
	int free;
	int percent;
}NETWORK_INFO_DATA;

typedef struct
{
	SDCARD_INFO_DATA  sd1;
	SDCARD_INFO_DATA  sd2;
	USB_INFO_DATA     usb;
	NETWORK_INFO_DATA     network;
}STORAGE_INFO_DATA;

typedef struct
{
	char kernelVersion[256];
	char fsVersion[256];
}SYSTEM_VERSION_DATA;

typedef struct
{
	struct tm time;
	int tz;
}TIMESET_MSG_DATA;

typedef struct
{
	int doBridge;

	char wireMac[256];

	char ipType[256];
	char ip[256];
	char gateway[256];
	char netmask[256];
	char dns1[256];
	int  dns1Exsit;
	char dns2[256];
	int dns2Exsit;

	int isWirelessUp;
	//20130626
	char wirelessIp[256];
	char wirelessGateway[256];
	char wirelessNetmask[256];
	//20130626 end
	char wirelessMac[256];
	char essid[256];
	char operationMode[256];
	char bitRate[256];
	char freq[256];
	char accessPoint[256];
	char encryptType[256];

	unsigned char linkquality;
	//unsigned char signallevel;
	//unsigned char noise;
	int signallevel;
	int noise;

	int cloudLogined;
	char cloudId[128];
	int cloudEnable;
	int cloudType;
	//add end
}NETWORK_STATUS_DATA;

#define MAX_WIFI_AP_CNT  50

#define WIFI_AUTH_OPEN   		0
#define WIFI_AUTH_SHARED   		1
#define WIFI_AUTH_WPAPSK   		2
#define WIFI_AUTH_WPA2PSK   	3
#define WIFI_AUTH_UNSPPORT   	4

#define WIFI_ENCRYP_NONE  		0
#define WIFI_ENCRYP_WEP   		1
#define WIFI_ENCRYP_TKIP  		2
#define WIFI_ENCRYP_AES   		3
#define WIFI_ENCRYP_UNSPPORT 	4

typedef struct
{
	char ssid[128];
	char wirelessMode[64];
	int authMode;
	int encryType;
	int quality;
	int signalLevel;
	int noiseLevel;
#if PLATFORM_MSTAR
	int channelnum;
#endif
}WIFI_AP_INFO;

typedef struct
{
	int apCnt;
	WIFI_AP_INFO  apInfos[MAX_WIFI_AP_CNT];
}WIFI_AP_SCAN;


typedef enum
{
	SHOWDATA_PRINTF,
	SHOWDATA_DEBUG,
	SHOWDATA_NONE,
}ShowDataType;



#define CMD_USER_MANAGE_BASE				100
#define CMD_USER_LOGIN						(CMD_USER_MANAGE_BASE + 1)
#define CMD_SESSION_UPDATE					(CMD_USER_MANAGE_BASE + 2)
#define CMD_SESSION_CHECK					(CMD_USER_MANAGE_BASE + 3)
#define CMD_USER_LOGOUT						(CMD_USER_MANAGE_BASE + 4)
#define CMD_USER_ADDUSER					(CMD_USER_MANAGE_BASE + 5)
#define CMD_USER_EDITUSER					(CMD_USER_MANAGE_BASE + 6)
#define CMD_USER_DELUSER					(CMD_USER_MANAGE_BASE + 7)
#define CMD_USER_GETPASSWORD				(CMD_USER_MANAGE_BASE + 8)
#define CMD_USER_ADD_OR_EDIT_USER			(CMD_USER_MANAGE_BASE + 9)
#define CMD_USER_MANAGE_LAST				(CMD_USER_MANAGE_BASE + 9)
///////////////////////////////////////////////////////////////////////////////////////////////////
//PTZ control command
///////////////////////////////////////////////////////////////////////////////////////////////////
#define CMD_PTZ_BASE						120
#define CMD_PTZ_CONTROL						(CMD_PTZ_BASE + 0)
#define CMD_PTZ_CONTROL_TRANS_DATA			(CMD_PTZ_BASE + 1)
#define CMD_PLATFORM_CONTROL				(CMD_PTZ_BASE + 4)
///////////////////////////////////////////////////////////////////////////////////////////////////
//reverse audio command
///////////////////////////////////////////////////////////////////////////////////////////////////
#define CMD_REVERSE_AUDIO_BASE				140
#define CMD_START_REVERSE_AUDIO				(CMD_REVERSE_AUDIO_BASE + 0)
#define CMD_REVERSE_AUDIO_DATA				(CMD_REVERSE_AUDIO_BASE + 1)
#define CMD_STOP_REVERSE_AUDIO				(CMD_REVERSE_AUDIO_BASE + 2)
#define CMD_REVERSE_AUDIO_LAST				(CMD_REVERSE_AUDIO_BASE + 3)
///////////////////////////////////////////////////////////////////////////////////////////////////
//CONGIG SET AND GET
///////////////////////////////////////////////////////////////////////////////////////////////////
//system config cmd
#define CMD_SYSTEM_CONFIG_BASE				200
#define CMD_GET_SYSTEM_CONFIG				(CMD_SYSTEM_CONFIG_BASE + 0)
#define CMD_GET_SYSTEM_PTZ_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 1)
#define CMD_GET_SYSTEM_TIME_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 2)
#define CMD_GET_SYSTEM_USER_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 3)
#define CMD_GET_SYSTEM_LOG_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 4)
#define CMD_GET_SYSTEM_MISC_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 5)
#define CMD_GET_SYSTEM_MAINTAIN_CONFIG		(CMD_SYSTEM_CONFIG_BASE + 6)
#define CMD_GET_SYSTEM_ALOWIP_CONFIG		(CMD_SYSTEM_CONFIG_BASE + 7)
#define CMD_GET_SYSTEM_ALARMCLOCK_CONFIG	(CMD_SYSTEM_CONFIG_BASE + 8)
#define CMD_GET_SYSTEM_LAST	(CMD_SYSTEM_CONFIG_BASE + 19)
#define CMD_SET_SYSTEM_CONFIG				(CMD_SYSTEM_CONFIG_BASE + 20)
#define CMD_SET_SYSTEM_PTZ_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 21)
#define CMD_SET_SYSTEM_TIME_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 22)
#define CMD_SET_SYSTEM_USER_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 23)
#define CMD_SET_SYSTEM_LOG_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 24)
#define CMD_SET_SYSTEM_PTZ_COMMON			(CMD_SYSTEM_CONFIG_BASE + 25)
#define CMD_SET_SYSTEM_PTZ_ADVANCE			(CMD_SYSTEM_CONFIG_BASE + 26)
#define CMD_SET_SYSTEM_MISC_CONFIG			(CMD_SYSTEM_CONFIG_BASE + 27)
#define CMD_SET_SYSTEM_MAINTAIN_CONFIG		(CMD_SYSTEM_CONFIG_BASE + 28)
#define CMD_SET_SYSTEM_ALOWIP_CONFIG		(CMD_SYSTEM_CONFIG_BASE + 29)
#define CMD_SET_SYSTEM_ALARMCLOCK_CONFIG	(CMD_SYSTEM_CONFIG_BASE + 30)
#define CMD_SYSTEM_CONFIG_LAST		(CMD_SYSTEM_CONFIG_BASE + 49)
#define CMD_NETWORK_CONFIG_BASE				300
#define CMD_GET_NETWORK_CONFIG				(CMD_NETWORK_CONFIG_BASE + 0)
//#define CMD_GET_NETWORK_COMMON_CONFIG		(CMD_NETWORK_CONFIG_BASE + 1)
//#define CMD_GET_NETWORK_IPACQUIRE_CONFIG	(CMD_NETWORK_CONFIG_BASE + 2)
#define CMD_GET_NETWORK_LAN_CONFIG   		(CMD_NETWORK_CONFIG_BASE + 5)
#define CMD_GET_NETWORK_WIFI_CONFIG			(CMD_NETWORK_CONFIG_BASE + 6)
#define CMD_GET_NETWORK_ADSL_CONFIG			(CMD_NETWORK_CONFIG_BASE + 10)
#define CMD_GET_NETWORK_DDNS_CONFIG			(CMD_NETWORK_CONFIG_BASE + 11)
#define CMD_GET_NETWORK_UPNP_CONFIG			(CMD_NETWORK_CONFIG_BASE + 12)
#define CMD_GET_NETWORK_G3_CONFIG			(CMD_NETWORK_CONFIG_BASE + 13)
#define CMD_GET_NETWORK_3G_CONFIG			CMD_GET_NETWORK_G3_CONFIG
#define CMD_GET_NETWORK_PPTP_CONFIG			(CMD_NETWORK_CONFIG_BASE + 14)
#define CMD_GET_NETWORK_P2P_CONFIG			(CMD_NETWORK_CONFIG_BASE + 15)
#define CMD_GET_NETWORK_WIFIAP_CONFIG		(CMD_NETWORK_CONFIG_BASE + 16)
#define CMD_GET_NETWORK_LAST			(CMD_NETWORK_CONFIG_BASE + 19)
#define CMD_SET_NETWORK_CONFIG			 	(CMD_NETWORK_CONFIG_BASE + 20)
//#define CMD_SET_NETWORK_COMMON_CONFIG		(CMD_NETWORK_CONFIG_BASE + 21)
//#define CMD_SET_NETWORK_IPACQUIRE_CONFIG	(CMD_NETWORK_CONFIG_BASE + 22)
#define CMD_SET_NETWORK_LAN_CONFIG			(CMD_NETWORK_CONFIG_BASE + 25)
#define CMD_SET_NETWORK_WIFI_CONFIG			(CMD_NETWORK_CONFIG_BASE + 26)
#define CMD_SET_NETWORK_ADSL_CONFIG			(CMD_NETWORK_CONFIG_BASE + 30)
#define CMD_SET_NETWORK_DDNS_CONFIG			(CMD_NETWORK_CONFIG_BASE + 31)
#define CMD_SET_NETWORK_UPNP_CONFIG			(CMD_NETWORK_CONFIG_BASE + 32)
#define CMD_SET_NETWORK_G3_CONFIG			(CMD_NETWORK_CONFIG_BASE + 33)
#define CMD_SET_NETWORK_3G_CONFIG			CMD_SET_NETWORK_G3_CONFIG
#define CMD_SET_NETWORK_PPTP_CONFIG			(CMD_NETWORK_CONFIG_BASE + 34)
#define CMD_SET_NETWORK_P2P_CONFIG			(CMD_NETWORK_CONFIG_BASE + 35)
#define CMD_SET_NETWORK_WIFIAP_CONFIG		(CMD_NETWORK_CONFIG_BASE + 36)
#define CMD_GET_DEFAULT_NETWORK_LAN_CONFIG  (CMD_NETWORK_CONFIG_BASE + 37)
#define CMD_NETWORK_CONFIG_LAST				(CMD_NETWORK_CONFIG_BASE + 49)
//server config cmd
#define CMD_SERVER_CONFIG_BASE				400
#define CMD_GET_SERVER_CONFIG				(CMD_SERVER_CONFIG_BASE + 0)
#define CMD_GET_SERVER_FTP_CONFIG			(CMD_SERVER_CONFIG_BASE + 1)
#define CMD_GET_SERVER_SMTP_CONFIG			(CMD_SERVER_CONFIG_BASE + 2)
#define CMD_GET_SERVER_LAST		(CMD_SERVER_CONFIG_BASE + 19)
#define CMD_SET_SERVER_CONFIG				(CMD_SERVER_CONFIG_BASE + 20)
#define CMD_SET_SERVER_FTP_CONFIG			(CMD_SERVER_CONFIG_BASE + 21)
#define CMD_SET_SERVER_SMTP_CONFIG			(CMD_SERVER_CONFIG_BASE + 22)
#define CMD_SERVER_CONFIG_LAST			(CMD_SERVER_CONFIG_BASE + 49)
//media config cmd
#define CMD_MEDIA_CONFIG_BASE				500
#define CMD_GET_MEDIA_CONFIG				(CMD_MEDIA_CONFIG_BASE + 0)
#define CMD_GET_MEDIA_VIDEO_CONFIG			(CMD_MEDIA_CONFIG_BASE + 1)
#define CMD_GET_MEDIA_AUDIO_CONFIG			(CMD_MEDIA_CONFIG_BASE + 2)
#define CMD_GET_MEDIA_VIDEO_ENCODE			(CMD_MEDIA_CONFIG_BASE + 3)
#define CMD_GET_MEDIA_VIDEO_CAPTURE			(CMD_MEDIA_CONFIG_BASE + 4)
#define CMD_GET_MEDIA_VIDEO_OSD				(CMD_MEDIA_CONFIG_BASE + 5)
#define CMD_GET_MEDIA_VIDEO_JPEG			(CMD_MEDIA_CONFIG_BASE + 6)
#define CMD_GET_MEDIA_AUDIO_CAPTURE			(CMD_MEDIA_CONFIG_BASE + 7)
#define CMD_GET_MEDIA_AUDIO_ENCODE			(CMD_MEDIA_CONFIG_BASE + 8)
#define CMD_GET_MEDIA_VIDEO_MASK			(CMD_MEDIA_CONFIG_BASE + 9)
#define CMD_GET_MEDIA_VIDEO_ROI				(CMD_MEDIA_CONFIG_BASE + 10)
#define CMD_GET_MEDIA_LAST		(CMD_MEDIA_CONFIG_BASE + 19)
#define CMD_SET_MEDIA_CONFIG				(CMD_MEDIA_CONFIG_BASE + 20)
#define CMD_SET_MEDIA_VIDEO_CONFIG			(CMD_MEDIA_CONFIG_BASE + 21)
#define CMD_SET_MEDIA_AUDIO_CONFIG			(CMD_MEDIA_CONFIG_BASE + 22)
#define CMD_SET_MEDIA_VIDEO_ENCODE			(CMD_MEDIA_CONFIG_BASE + 23)
#define CMD_SET_MEDIA_VIDEO_CAPTURE			(CMD_MEDIA_CONFIG_BASE + 24)
#define CMD_SET_MEDIA_VIDEO_OSD				(CMD_MEDIA_CONFIG_BASE + 25)
#define CMD_SET_MEDIA_VIDEO_JPEG			(CMD_MEDIA_CONFIG_BASE + 26)
#define CMD_SET_MEDIA_AUDIO_CAPTURE			(CMD_MEDIA_CONFIG_BASE + 27)
#define CMD_SET_MEDIA_AUDIO_ENCODE			(CMD_MEDIA_CONFIG_BASE + 28)
#define CMD_SET_MEDIA_VIDEO_MASK			(CMD_MEDIA_CONFIG_BASE + 29)
#define CMD_SET_MEDIA_VIDEO_ROI				(CMD_MEDIA_CONFIG_BASE + 30)
#define CMD_MEDIA_CONFIG_LAST			(CMD_MEDIA_CONFIG_BASE + 49)
//mediastream config cmd
#define CMD_MEDIASTREAM_CONFIG_BASE			600
#define CMD_GET_MEDIASTREAM_CONFIG			(CMD_MEDIASTREAM_CONFIG_BASE + 0)
#define CMD_GET_MEDIASTREAM_LAST			(CMD_MEDIASTREAM_CONFIG_BASE + 19)
#define CMD_SET_MEDIASTREAM_CONFIG			(CMD_MEDIASTREAM_CONFIG_BASE + 20)
#define CMD_MEDIASTREAM_CONFIG_LAST			(CMD_MEDIASTREAM_CONFIG_BASE + 49)
#define CMD_PLATFORM_CONFIG_BASE			650
#define CMD_GET_PLATFORM_CONFIG				(CMD_PLATFORM_CONFIG_BASE + 0)
#define CMD_GET_PLATFORM_CONFIG_LAST				(CMD_PLATFORM_CONFIG_BASE + 19)
#define CMD_SET_PLATFORM_CONFIG				(CMD_PLATFORM_CONFIG_BASE + 20)
#define CMD_PLATFORM_CONFIG_LAST			(CMD_PLATFORM_CONFIG_BASE + 29)
#define CMD_GB28181_CONFIG_BASE				680
#define CMD_GET_GB28181_CONFIG				(CMD_GB28181_CONFIG_BASE + 0)
#define CMD_SET_GB28181_CONFIG				(CMD_GB28181_CONFIG_BASE + 1)
#define CMD_GB28181_CONFIG_LAST				(CMD_GB28181_CONFIG_BASE + 2)
//record config cmd
#define CMD_RECORD_CONFIG_BASE				700
#define CMD_GET_RECORD_CONFIG				(CMD_RECORD_CONFIG_BASE + 0)
#define CMD_GET_RECORD_CONFIG_LAST			(CMD_RECORD_CONFIG_BASE + 19)
#define CMD_SET_RECORD_CONFIG				(CMD_RECORD_CONFIG_BASE + 20)
#define CMD_RECORD_CONFIG_LAST			(CMD_RECORD_CONFIG_BASE + 49)
//alarm config cmd
#define CMD_ALARM_CONFIG_BASE				800
#define CMD_GET_ALARM_CONFIG				(CMD_ALARM_CONFIG_BASE + 0)
#define CMD_GET_ALARM_INPUT_CONFIG			(CMD_ALARM_CONFIG_BASE + 1)
#define CMD_GET_ALARM_MOTIONDETECT_CONFIG	(CMD_ALARM_CONFIG_BASE + 2)
#define CMD_GET_ALARM_VIDEOCOVER_CONFIG		(CMD_ALARM_CONFIG_BASE + 3)
#define CMD_GET_ALARM_VIDEOLOST_CONFIG		(CMD_ALARM_CONFIG_BASE + 4)
#define CMD_GET_ALARM_SF_CONFIG				(CMD_ALARM_CONFIG_BASE + 5)
#define CMD_GET_ALARM_AUDIO_CONFIG			(CMD_ALARM_CONFIG_BASE + 6)
#define CMD_GET_ALARM_VIDEO_GATE			(CMD_ALARM_CONFIG_BASE + 7)
#define CMD_GET_ALARM_PD	(CMD_ALARM_CONFIG_BASE + 8)
#define CMD_GET_ALARM_LAST	(CMD_ALARM_CONFIG_BASE + 19)
#define CMD_SET_ALARM_CONFIG				(CMD_ALARM_CONFIG_BASE + 20)
#define CMD_SET_ALARM_INPUT_CONFIG			(CMD_ALARM_CONFIG_BASE + 21)
#define CMD_SET_ALARM_MOTIONDETECT_CONFIG	(CMD_ALARM_CONFIG_BASE + 22)
#define CMD_SET_ALARM_VIDEOCOVER_CONFIG		(CMD_ALARM_CONFIG_BASE + 23)
#define CMD_SET_ALARM_VIDEOLOST_CONFIG		(CMD_ALARM_CONFIG_BASE + 24)
#define CMD_SET_ALARM_SF_CONFIG				(CMD_ALARM_CONFIG_BASE + 25)
#define CMD_SET_ALARM_INPUT_CHANNEL_CONFIG	(CMD_ALARM_CONFIG_BASE + 26)
#define CMD_SET_ALARM_AUDIO_CONFIG			(CMD_ALARM_CONFIG_BASE + 27)
#define CMD_SET_ALARM_VIDEO_GATE			(CMD_ALARM_CONFIG_BASE + 28)
#define CMD_SET_ALARM_PD	(CMD_ALARM_CONFIG_BASE + 29)
#define CMD_ALARM_CONFIG_LAST				(CMD_ALARM_CONFIG_BASE + 49)
#define CMD_GET_CONFIG_FIELD_VALUE			900
// config manager cmd
#define CMD_SYSTEM_MANAGE_BASE				1000
#define CMD_CONFIG_UPDATE					(CMD_SYSTEM_MANAGE_BASE + 1)
#define CMD_CONFIG_RESTORE					(CMD_SYSTEM_MANAGE_BASE + 2)
#define CMD_CONFIG_BACKUP					(CMD_SYSTEM_MANAGE_BASE + 3)
#define CMD_SET_SYSTEM_TIME					(CMD_SYSTEM_MANAGE_BASE + 5)
#define CMD_SYSTEM_REBOOT					(CMD_SYSTEM_MANAGE_BASE + 7)
#define CMD_RECORD_REMOVE					(CMD_SYSTEM_MANAGE_BASE + 8)
#define CMD_APPBIN_LOCAL_UPDATE 			(CMD_SYSTEM_MANAGE_BASE + 9)
#define CMD_SYSTEM_UPDATE_FRAM				CMD_APPBIN_LOCAL_UPDATE
#define CMD_APPBIN_FTP_UPDATE  				(CMD_SYSTEM_MANAGE_BASE + 10)
#define CMD_GET_SYSTEM_VERSION_INFO			(CMD_SYSTEM_MANAGE_BASE + 12)
#define CMD_GET_LOG_CONFIG      			(CMD_SYSTEM_MANAGE_BASE + 13)
#define CMD_GET_STORAGE_INFO 				(CMD_SYSTEM_MANAGE_BASE + 14)
#define CMD_RECORD_START					(CMD_SYSTEM_MANAGE_BASE + 15)
#define CMD_RECORD_STOP						(CMD_SYSTEM_MANAGE_BASE + 16)
#define CMD_STORAGE_DEVICE_FORMAT			(CMD_SYSTEM_MANAGE_BASE + 17)
#define CMD_STORAGE_DEVICE_UNMOUNT			(CMD_SYSTEM_MANAGE_BASE + 18)
#define CMD_GET_SERIALNUMBER				(CMD_SYSTEM_MANAGE_BASE + 19)
#define CMD_GET_SYSTEMCONTROLSTRING			(CMD_SYSTEM_MANAGE_BASE + 20)
#define CMD_GET_RECORD_FILE_LIST			(CMD_SYSTEM_MANAGE_BASE + 21)
#define CMD_UPLOAD_FILE						(CMD_SYSTEM_MANAGE_BASE + 22)
#define CMD_DOWNLOAD_FILE					(CMD_SYSTEM_MANAGE_BASE + 23)
#define CMD_REMOVE_FILE						(CMD_SYSTEM_MANAGE_BASE + 24)
#define CMD_GET_LOGFILE_LIST				(CMD_SYSTEM_MANAGE_BASE + 25)
#define CMD_GET_NETWORK_STATUS				(CMD_SYSTEM_MANAGE_BASE + 26)
#define CMD_CONFIG_NETWORK					(CMD_SYSTEM_MANAGE_BASE + 27)
#define CMD_SET_REPLAY_FILENAME				(CMD_SYSTEM_MANAGE_BASE + 28)
#define CMD_GET_REPLAY_FILENAME				(CMD_SYSTEM_MANAGE_BASE + 29)
#define CMD_GET_IPC_TYPE					(CMD_SYSTEM_MANAGE_BASE + 30)
//added by 20111110
#define CMD_GET_MEDIA_CAPABILITY			(CMD_SYSTEM_MANAGE_BASE + 31)
#define CMD_SET_KEYFRAME					(CMD_SYSTEM_MANAGE_BASE + 32)
#define CMD_SET_USER_DEV_DATA				(CMD_SYSTEM_MANAGE_BASE + 33)
#define CMD_GET_USER_DEV_DATA				(CMD_SYSTEM_MANAGE_BASE + 34)
#define CMD_OPEN_RS232_PORT					(CMD_SYSTEM_MANAGE_BASE + 35)
#define CMD_CLOSE_RS232_PORT				(CMD_SYSTEM_MANAGE_BASE + 36)
#define CMD_START_RTP_PUSH					(CMD_SYSTEM_MANAGE_BASE + 40)
#define CMD_STOP_RTP_PUSH					(CMD_SYSTEM_MANAGE_BASE + 41)
#define CMD_ALARM_OUTPUT_CONTROL			(CMD_SYSTEM_MANAGE_BASE + 42)
#define CMD_SNAP_JPEG_PICTURE				(CMD_SYSTEM_MANAGE_BASE + 43)
#define CMD_NETWORK_DIAL					(CMD_SYSTEM_MANAGE_BASE + 45)
#define CMD_IRCUT_CONTROL					(CMD_SYSTEM_MANAGE_BASE + 46)
#define CMD_DAYNIGHT_MODEL					CMD_IRCUT_CONTROL
#define CMD_SET_AUX_DATA					(CMD_SYSTEM_MANAGE_BASE + 47)
#define CMD_GET_SYSTEM_TIME					(CMD_SYSTEM_MANAGE_BASE + 48)
#define CMD_GET_PTZ_CAPABILITY				(CMD_SYSTEM_MANAGE_BASE + 49)
#define CMD_GET_WIFI_AP_INFO				(CMD_SYSTEM_MANAGE_BASE + 50)
#define CMD_REGISTER_DDNS          			(CMD_SYSTEM_MANAGE_BASE + 51)
#define CMD_DDNS_AUTO_REGDOMAIN				CMD_REGISTER_DDNS
#define CMD_TZ_CHANGE                		(CMD_SYSTEM_MANAGE_BASE + 52)
#define CMD_SET_GATEWAY            			(CMD_SYSTEM_MANAGE_BASE + 53)
#define CMD_SET_IP                    		(CMD_SYSTEM_MANAGE_BASE + 54)
#define CMD_SET_DNS           				(CMD_SYSTEM_MANAGE_BASE + 55)
#define CMD_SET_DHCP         				(CMD_SYSTEM_MANAGE_BASE + 56)
#define CMD_56U48V_MODULE_CONTROL			(CMD_SYSTEM_MANAGE_BASE + 70)
#define CMD_LSA_P2P_REGISTER				(CMD_SYSTEM_MANAGE_BASE + 71)
#define CMD_LSA_P2P_GET_REGISTER_INFO		(CMD_SYSTEM_MANAGE_BASE + 72)
#define CMD_P2P_GET_LOGIN_STATE				(CMD_SYSTEM_MANAGE_BASE + 73)
#define CMD_LENS_MOTO_CTRL					(CMD_SYSTEM_MANAGE_BASE + 75)
#define CMD_MOTO_PRESET_CTRL				(CMD_SYSTEM_MANAGE_BASE + 76)
#define CMD_CUSTOM_BOMB_CTRL				(CMD_SYSTEM_MANAGE_BASE + 77)
#define CMD_SET_SYSTEM_TIME_ONLY			(CMD_SYSTEM_MANAGE_BASE + 78)	//仅设置时间，不改变时区
#define CMD_STOP_WIRELESS_CONFIG			(CMD_SYSTEM_MANAGE_BASE + 79)	//停止网络设置
#define CMD_CONFIG_NETWORK_ALWAYS			(CMD_SYSTEM_MANAGE_BASE + 80)	//无论如何都设置网络
#define CMD_SET_MEIDA_IMAGE_PARAM			(CMD_SYSTEM_MANAGE_BASE + 81)
#define CMD_TEST_SMTP						(CMD_SYSTEM_MANAGE_BASE + 82)
#define CMD_SET_PLAYAUDIO_START				(CMD_SYSTEM_MANAGE_BASE + 83)
#define CMD_SET_PLAYAUDIO_STOP				(CMD_SYSTEM_MANAGE_BASE + 84)
#define CMD_GET_IO_INPUT_STATUS				(CMD_SYSTEM_MANAGE_BASE + 85)
#define CMD_GET_IO_OUTPUT_STATUS			(CMD_SYSTEM_MANAGE_BASE + 86)
#define CMD_GET_AUDIO_STATUS				(CMD_SYSTEM_MANAGE_BASE + 87)//获取当前音频播放工作状态: READY/REVERSE AUDIO/PLAYING FILE
#define CMD_FLICK_IO_OUTPUT_CTRL_START		(CMD_SYSTEM_MANAGE_BASE + 88) //io交替输出(单个PORT或者2个PORT)
#define CMD_FLICK_IO_OUTPUT_CTRL_STOP		(CMD_SYSTEM_MANAGE_BASE + 89) //io交替输出(单个PORT或者2个PORT)
#define CMD_SN_REQUEST						(CMD_SYSTEM_MANAGE_BASE + 90)
#define CMD_SN_CONFIRM						(CMD_SYSTEM_MANAGE_BASE + 91)
#define CMD_SN_INFOMATION					(CMD_SYSTEM_MANAGE_BASE + 92)
#define CMD_TEST_FTP   (CMD_SYSTEM_MANAGE_BASE + 93)
#define CMD_SYSTEM_MANAGE_LAST			1093
#define CMD_MAX_COMAND						1200

#ifndef __stdcall
#define __stdcall
#endif // !__stdcall


#ifndef CALLBACK
#define CALLBACK
#endif



#endif //LIBNETSDK_SDK_DEFINE_H
