// PlayerWnd.cpp : ʵļ
//

#include "stdafx.h"
#include "AjNetSdkDemo.h"
#include "PlayerWnd.h"
#include "DlgRemote.h"
#include "NetSDKDevice.h"
// CPlayerWnd

IMPLEMENT_DYNAMIC(CPlayerWnd, CWnd)

CPlayerWnd::CPlayerWnd(unsigned int index)
{
	m_iIndex = index;
	m_lReaderID = index + 1000;
	m_pDevice = NULL;
	m_wndMenu.LoadMenu(IDR_MENU_PLAYWND);
}

CPlayerWnd::~CPlayerWnd()
{
//	AJ_PLAYER_DeletePlayer(m_lReaderID);
	DestroyWindow();	
}


BEGIN_MESSAGE_MAP(CPlayerWnd, CWnd)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_STREAM_MAIN, &CPlayerWnd::OnStreamMain)
	ON_COMMAND(ID_STREAM_SUB, &CPlayerWnd::OnStreamSub)
	ON_COMMAND(ID_IMAGE_NORMAL, &CPlayerWnd::OnImageNormal)
	ON_COMMAND(ID_IMAGE_FULL, &CPlayerWnd::OnImageFull)
	ON_COMMAND(ID_STOPPLAY_ONE, &CPlayerWnd::OnStopplayOne)
	ON_COMMAND(ID_STOPALLPLAY, &CPlayerWnd::OnStopallplay)
	ON_COMMAND(ID_SYNCTIME, &CPlayerWnd::OnSynctime)
	ON_COMMAND(ID_REMOTE, &CPlayerWnd::OnRemote)
	ON_COMMAND(ID_RECORD_START, &CPlayerWnd::OnRecordStart)
	ON_COMMAND(ID_RECORD_STOP, &CPlayerWnd::OnRecordStop)
END_MESSAGE_MAP()



// CPlayerWnd Ϣ
void CPlayerWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO:  ڴ˴Ϣ
	// ΪͼϢ CWnd::OnPaint()
	CRect rcClient;
	GetClientRect(&rcClient);
	dc.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(45, 45, 48));
	SetWndFocus(FALSE);
}

int CPlayerWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO:  ڴרõĴ
	m_wndPlayer.Create(_T(""), WS_CHILD | WS_VISIBLE, CRect(0, 0, 0, 0), this, m_lReaderID);

	m_lReaderID = AJ_PLAYER_CreatePlayer(m_wndPlayer.GetSafeHwnd());
	return 0;
}

void CPlayerWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	CRect rcClient;
	GetClientRect(rcClient);
	rcClient.DeflateRect(1, 1, 1, 1);
	if (m_wndPlayer.GetSafeHwnd())
	{
		m_wndPlayer.MoveWindow(rcClient);
	}
}

HBRUSH CPlayerWnd::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CWnd::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  ڴ˸ DC κ
	static BOOL isfirst = TRUE;
	static CBrush oBrush;
	if (isfirst)
	{
		oBrush.CreateSolidBrush(RGB(45, 45, 48));
		isfirst = FALSE;
	}
	return oBrush;
	// TODO:  ĬϵĲ軭ʣ򷵻һ
	return hbr;
}

void CPlayerWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO:  ڴϢ/Ĭֵ
	GetParent()->PostMessage(UM_PLAYWND_SELECT,m_iIndex);
	CWnd::OnLButtonDown(nFlags, point);
}

void CPlayerWnd::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO:  ڴϢ/Ĭֵ
	GetParent()->PostMessage(UM_PLAYWND_SELECT, m_iIndex);
	CPoint pt;
	GetCursorPos(&pt);
	if (m_pDevice)
	{
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(3, MF_BYPOSITION | MF_ENABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(6, MF_BYPOSITION | MF_ENABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(7, MF_BYPOSITION | MF_ENABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(8, MF_BYPOSITION | MF_ENABLED);
		if (m_pDevice->GetPlayStream() == 0)
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(0)->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(0)->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
		}
		else
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(0)->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(0)->CheckMenuItem(1, MF_BYPOSITION | MF_CHECKED);
		}
		if (m_pDevice->GetRecordStream() >= 0)
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(8)->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(8)->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
		}
		else
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(8)->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(8)->CheckMenuItem(1, MF_BYPOSITION | MF_CHECKED);
		}
		if (AJ_PLAYER_GetFullFillStatus(m_lReaderID) == 0)
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(1)->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(1)->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
		}
		else
		{
			m_wndMenu.GetSubMenu(0)->GetSubMenu(1)->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
			m_wndMenu.GetSubMenu(0)->GetSubMenu(1)->CheckMenuItem(1, MF_BYPOSITION | MF_CHECKED);
		}
		
	}
	else
	{
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(0, MF_BYPOSITION | MF_DISABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(1, MF_BYPOSITION | MF_DISABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(3, MF_BYPOSITION | MF_DISABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(6, MF_BYPOSITION | MF_DISABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(7, MF_BYPOSITION | MF_DISABLED);
		m_wndMenu.GetSubMenu(0)->EnableMenuItem(8, MF_BYPOSITION | MF_DISABLED);
	}
	m_wndMenu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN |
		TPM_RIGHTBUTTON, pt.x, pt.y, this, NULL);
	
	CWnd::OnRButtonDown(nFlags, point);
}

//////////////////////////////////////////////////////////////////////////
//
void CPlayerWnd::SetWndFocus(BOOL bSelect)
{
	CDC *pDC = GetWindowDC();
	CRect rect;
	GetWindowRect(rect);
	ScreenToClient(rect);
	CPen	*pOldPen = NULL;
	CPen	CRectPen(PS_SOLID, 2, RGB(236, 233, 216));
	CPen	CRectPen2(PS_SOLID, 2, RGB(255, 0, 0));
	if (bSelect)
		pOldPen = pDC->SelectObject(&CRectPen2);
	else
		pOldPen = pDC->SelectObject(&CRectPen);
	pDC->MoveTo(rect.left, rect.top);
	pDC->LineTo(rect.right, rect.top);
	pDC->LineTo(rect.right, rect.bottom);
	pDC->LineTo(rect.left, rect.bottom);
	pDC->LineTo(rect.left, rect.top);
	pOldPen = pDC->SelectObject(&CRectPen);
	pDC->SelectObject(pOldPen);
	ReleaseDC(pDC);
	CRectPen.Detach();
	CRectPen.DeleteObject();
	CRectPen2.Detach();
	CRectPen2.DeleteObject();
	pOldPen->DeleteObject();
}

LONG CPlayerWnd::GetReaderID()
{
	return m_lReaderID;
}

HWND CPlayerWnd::GetPlayWnd()
{
	return m_wndPlayer.GetSafeHwnd();
}

void CPlayerWnd::SetDevice(CDeviceBase* pDevice)
{
	m_pDevice = pDevice;
	if (pDevice == NULL)
	{
		AJ_PLAYER_ClearBufferTick(m_lReaderID);
		//IP_TPS_ClearBuffer(m_lReaderID);
		m_wndPlayer.Invalidate();
	}
}

CDeviceBase* CPlayerWnd::GetDevice()
{
	return m_pDevice;
}

void CPlayerWnd::OnStreamMain()
{
	if (m_pDevice)
	{
		PLAYWND_PARAM * pParam = new PLAYWND_PARAM;
		pParam->iWndIndex = m_iIndex;
		pParam->isSub = 0;
		theApp.m_pMainWnd->PostMessage(UM_DEVICE_PLAY,(WPARAM)m_pDevice,(LPARAM)pParam);
	}
}


void CPlayerWnd::OnStreamSub()
{
	if (m_pDevice)
	{
		PLAYWND_PARAM * pParam = new PLAYWND_PARAM;
		pParam->iWndIndex = m_iIndex;
		pParam->isSub = 1;
		theApp.m_pMainWnd->PostMessage(UM_DEVICE_PLAY, (WPARAM)m_pDevice, (LPARAM)pParam);
	}
}


void CPlayerWnd::OnImageNormal()
{
	if (m_pDevice && m_lReaderID > 0)
	{
		AJ_PLAYER_SetFullFillStatus(m_lReaderID, 0);
	}
}


void CPlayerWnd::OnImageFull()
{
	if (m_pDevice && m_lReaderID > 0)
	{
		AJ_PLAYER_SetFullFillStatus(m_lReaderID, 1);
	}
}


void CPlayerWnd::OnStopplayOne()
{
	if (m_pDevice)
	{
		theApp.m_pMainWnd->PostMessage(UM_DEVICE_STOPPLAY, (WPARAM)m_pDevice);
	}
}


void CPlayerWnd::OnStopallplay()
{
	theApp.m_pMainWnd->PostMessage(UM_DEVICE_STOPALLPLAY);
}


void CPlayerWnd::OnSynctime()
{
	// TODO:  ڴ
	USES_CONVERSION;
	if (m_pDevice)
	{
		CString szXML;
		szXML.Format(_T("<REQUEST_PARAM Stream=\"1\"Quality=\"100\"/>\n"));
		long iRet = AJ_NETSDK_IPC_SystemControl(((CNetSDKDevice*)m_pDevice)->m_lUserID, 1043, 0, W2A(szXML));
		int x = 1;
		if (iRet == 0)
		{

		}
		else
		{

		}
	}
	else
	{
		MessageBox(_T("ѡһڲŵĴ!"));
	}

}


void CPlayerWnd::OnRemote()
{
	// TODO:  ڴ
	if (m_pDevice)
	{
		CDlgRemote dlg(m_pDevice->m_szDevIP);
		dlg.DoModal();
	}
}


void CPlayerWnd::OnRecordStart()
{
	// TODO:  ڴ
	if (m_pDevice)
	{
		m_pDevice->StartRecord(0, 0);
	}
}


void CPlayerWnd::OnRecordStop()
{
	// TODO:  ڴ
	if (m_pDevice)
	{
		m_pDevice->StopRecord();
	}
}
